import runtime from 'react-refresh/runtime.js';

const components = new Map();

let timeoutId = null;
runtime.injectIntoGlobalHook(globalThis);

globalThis.$RefreshReg$ = type => {
  if (typeof type?.url !== "string") {
    return;
  }

  let pathname;

  try {
    pathname = new URL(type.url).pathname;
  } catch {
    return;
  }

  components.set(pathname, type);
  runtime.register(type, pathname);
  timeoutId ?? (timeoutId = setTimeout(() => {
    timeoutId = null;
    runtime.performReactRefresh();
  }, 30));
};

globalThis.$RefreshSig$ = runtime.createSignatureFunctionForTransform;

if (typeof EventSource === "function") {
  const sse = new EventSource("/sse");
  let i = 0;

  sse.onmessage = e => {
    const pathname = new URL(e.data).pathname;

    if (components.has(pathname)) {
      import(`${pathname}?${i++}`).catch(() => {});
    }
  };
}

export { components };
//# sourceMappingURL=index.client.js.map
