import { on } from 'events';
import { get } from 'http';
import { createInterface } from 'readline';
import { workerData } from 'worker_threads';
import runtime from 'react-refresh/runtime.js';

const components = new Map();

let timeoutId = null;
runtime.injectIntoGlobalHook(globalThis);

globalThis.$RefreshReg$ = type => {
  if (typeof type?.url !== "string") {
    return;
  }

  let pathname;

  try {
    pathname = new URL(type.url).pathname;
  } catch {
    return;
  }

  components.set(pathname, type);
  runtime.register(type, pathname);
  timeoutId ?? (timeoutId = setTimeout(() => {
    timeoutId = null;
    runtime.performReactRefresh();
  }, 30));
};

globalThis.$RefreshSig$ = runtime.createSignatureFunctionForTransform;

if (workerData?.devServerUrl) {
  let i = 0;
  get(`${workerData.devServerUrl}/sse`, async res => {
    for await (const [line] of on(createInterface(res), "line")) {
      if (!line.startsWith("data: ")) {
        continue;
      }

      const url = new URL(`?${i++}`, line.slice(6));

      if (components.has(url.pathname)) {
        import(url.href).catch(() => {});
      }
    }
  });
}

export { components };
//# sourceMappingURL=index.mjs.map
